//
// Author:
//   Mario Chavez <>
//
// (C) 2004 Mario Chavez
//

using System;
using System.Net;

namespace Imendio.Blam {
    public class Proxy {

        public Proxy() {}

        public static WebProxy GetProxy()
	{
	    WebProxy proxy = new WebProxy();

	    try {
		bool use_proxy;

		use_proxy = Conf.Get ("/system/http_proxy/use_http_proxy", false);
		if (use_proxy) {
                    string host;
		    int    port;
		    string proxyUrlString;

		    host = Conf.Get ("/system/http_proxy/host", "");
                    port = Conf.Get ("/system/http_proxy/port", 0);

		    proxyUrlString = "http://" + host + ":" + port.ToString();

                    //Console.WriteLine("Using proxy " + proxyUrlString);

                    Uri proxyUrl = new Uri (proxyUrlString);
                    proxy.Address = proxyUrl;

                    string username = Conf.Get ("/system/http_proxy/authentication_user", "");
		    string password = Conf.Get ("/system/http_proxy/authentication_password", "");
                    if (username != null) {
                       proxy.Credentials = new NetworkCredential (username, password);
		    }

		    return proxy;
		} else {
		    return null;
		}
	    } catch(Exception e) {
		return null;
	    }
	}
    }
}
